require "loco/liquid/filters/version"
require 'liquid'
require 'digest/md5'
require 'sanitize'
require 'uri'
require 'net/https'
require 'json'

module Loco
    module Liquid
        module Filters

            def gravatar(email, default)
                email = default if email.nil? || email.empty?
                hash = Digest::MD5.hexdigest(email)
                "http://www.gravatar.com/avatar/#{hash}"
            end

            def twitter(handle)
                "<a href='http://twitter.com/#{handle}' target='_blank'>@#{handle}</a>"
            end

            def teaser(html)
                if html.nil? || html.empty?
                    ""
                else
                    Sanitize.clean(html)[0..400] + "..."
                end
            end

            def url_encode(string)
                URI.escape string
            end

            def url_decode(string)
                URI.unescape string
            end

            def trim(string)
                string.strip
            end

            def random(max, min = 1)
                rand(min..max)
            end

            def httpsRestGet(domain,method, user, password)
                http = Net::HTTP.new(domain, 443)
                http.use_ssl = true
                http.start do |http|
                   req = Net::HTTP::Get.new(method)

                   # we make an HTTP basic auth by passing the
                   # username and password
                   req.basic_auth user, password

                   resp = http.request(req)
                   JSON.parse(resp.body)
                end   
            end

            def replaceURLStringWithHref(string)
                    urls = URI.extract(string)
                    urls = urls.uniq
                    urls.each do|u|
                        string.gsub!(u,"<a href="+u+">"+u+"</a>")
                    end
                    return string 
            end
        end
    end
end

Liquid::Template.register_filter(Loco::Liquid::Filters)